﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Regular
{
    public class Stav
    {
        /// <summary>
        /// Počítadlo stavů
        /// </summary>
        static int PocetStavu = 0;

        /// <summary>
        /// Číslo stavu
        /// </summary>
        public int Cislo { get; set; }

        /// <summary>
        /// Hrany vycházející ze stavu
        /// </summary>
        public List<Hrana> Hrany { get; set; }

        /// <summary>
        /// Určuje zda je tento stav konečný
        /// </summary>
        public bool KonecnyStav { get; set; }


        public Stav()
        {
            this.Cislo = PocetStavu;
            Stav.PocetStavu += 1;
            this.KonecnyStav = false;
            this.Hrany = new List<Hrana>();
        }
        /// <summary>
        /// Přidej tomuto stavu hranu, která z něj vychází
        /// </summary>
        /// <param name="znak">Znak, který tuto hranu odpálí</param>
        /// <param name="cisloNasledujicihoStavu">Číslo následujícího stavu</param>
        public void PridejHranu(char znak, int cisloNasledujicihoStavu)
        {
            this.Hrany.Add(new Hrana(znak, cisloNasledujicihoStavu));
        }
        /// <summary>
        /// Nastaví tento stav jako konečný
        /// </summary>
        public void JeKonecny()
        {
            this.KonecnyStav = true;
        }

    }
}