/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package regularnivyrazy;

import java.util.ArrayList;
import java.util.Arrays;

/**
 *
 * @author Krupi
 */
public class Validovac {
    private String vyraz;
    protected static final String validniZnaky = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 ";
    protected static final String cisla = "0123456789";
    protected static final String low = "abcdefghijklmnopqrstuvwxyz";
    protected static final String upp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    private static final String validniZnakyVyraz = "[]*+?-:^$";
    private ArrayList<Pismeno> pismena;
    public Validovac(String vyraz){
        this.vyraz = vyraz;
        pismena = new ArrayList<>();
    }
    
    public int validuj(String text){
        boolean mnozina = false;
        boolean prevraceno = false;
        boolean zacatek = false;
        Pismeno aktualni = null;
        if(vyraz.isEmpty())
            return 2;
        for(char c : vyraz.toCharArray()){
            boolean vyrazovyZnak = validniZnakyVyraz.contains(String.valueOf(c));
            if(!validniZnaky.contains(String.valueOf(c)) && !vyrazovyZnak){
                return 2;
            }
            switch(c){
                case '[':
                    if(!mnozina)
                        mnozina = true;
                    else
                        return 2;
                    break;
                case ']':
                    if(mnozina){
                        mnozina = false;
                        if(prevraceno)
                            aktualni.prevratit();
                        aktualni = null;
                    }
                    else
                        return 2;
                    break;
                case '-':
                    if(mnozina){
                        if(pismena.get(pismena.size() - 1).pridatZnak(c) == 1){
                            return 2;
                        }
                    }
                    else
                        return 2;
                    break;
                case ':':
                    if(mnozina){
                        if(aktualni == null){
                            aktualni = new Pismeno();
                            pismena.add(aktualni);
                        }
                        else if(aktualni.getDefinovanaMnozina() != null){
                            if(aktualni.pridatZnak(c) == 1)
                                return 2;
                        }
                        else
                            return 2;
                    }
                    else
                        return 2;
                    break;
                case '^':
                    if(mnozina){
                        if(prevraceno)
                            return 2;
                        else
                            prevraceno = true;
                    }
                    else {
                        zacatek = true;
                    }
                    break;
                case '$':
                    if(!pismena.isEmpty()){
                        if(pismena.get(pismena.size() - 1).pridatZnak(c) == 1)
                            return 2;
                    }
                break;
                default:
                    if(vyrazovyZnak && !pismena.isEmpty()){
                        if(pismena.get(pismena.size() - 1).pridatZnak(c) == 1)
                            return 2;
                    }
                    else if (vyrazovyZnak)
                        return 2;
                    else if(aktualni == null){
                        aktualni = new Pismeno(c);
                        pismena.add(aktualni);
                        if(!mnozina){
                            aktualni = null;
                        }
                    }
                    else {
                        if(aktualni.pridatZnak(c) == 1)
                            return 2;
                    }
                    break;
            }
        }
        if(mnozina)
            return 2;
        for(char c : text.toCharArray()){
            if(!validniZnaky.contains(String.valueOf(c))){
                return 2;
            }
        }
        int index = 0;
        if(pismena.isEmpty())
            return 0;
        boolean pouzitoOpakovaniZnaku = false;
        for(char c : text.toCharArray()){
            pouzitoOpakovaniZnaku = false;
            boolean opakovat = true;
            if(index == -1)
                return 1;
            while(opakovat){
                opakovat = false;
                switch(pismena.get(index).zkontrolovat(c)){
                    //Znak je obsažen, můžeme jít dál
                    case 0:
                        if(zacatek){
                            if(text.indexOf(String.valueOf(c)) == 0)
                                zacatek = false;
                            else
                                return 1;
                        }
                        if(index == pismena.size() - 1)
                            return 0;
                        index ++;
                        break;
                    //Znak není obsažen
                    case 1:
                        index = 0;
                        break;
                    //Znak je obsažen, ale je možnost opakování, proto zůstáváme na stejném místě
                    case 2:
                        pouzitoOpakovaniZnaku = true;
                        break;
                    //Znak není obsažen, ale je možnost přeskočení části výrazu, pripadně bylo pouzito opakovani
                    case 3:
                        index ++;
                        opakovat = true;
                        break;
                    //TODO
                    //Znak je obsažen, ale je potřeba kontrola kone
                    case 4:
                        if(text.lastIndexOf(String.valueOf(c)) == text.length() - 1)
                            return 0;
                        else
                            return 1;
                }
            }
        }
        if(pouzitoOpakovaniZnaku)
            return 0;
        return 1;
    }
    /**
     * @return the vyraz
     */
    public String getVyraz() {
        return vyraz;
    }

    /**
     * @param vyraz the vyraz to set
     */
    public void setVyraz(String vyraz) {
        this.vyraz = vyraz;
    }
}
