#include "common.h"
#include "regexObject.h"
#include "cmpChar.h"
#include "cmpChars.h"
#include "start.h"
#include "end.h"

uint32_t isValid(char *input){
	uint32_t i;
	for(i=0;i<strlen(input);++i){
		if(input[i]>='A' && input[i]<='Z')continue;
		if(input[i]>='a' && input[i]<='z')continue;
		if(input[i]>='0' && input[i]<='9')continue;
		if(input[i]==' ')continue;

		return ERROR;
	}

	return YES;
}

char* parseOne(char *regex, RegexObject*& parsed){
	uint32_t i=0;
	if((regex[i]>='A' && regex[i]<='Z') || (regex[i]>='a' && regex[i]<='z') || (regex[i]>='0' && regex[i]<='9') || regex[i]==' '){
		parsed = new CmpChar(regex[i]);
		++i;
	}else if(regex[i]=='['){
		++i;
		char *start = regex+i;
		uint32_t len=0;
		while(regex[i]!=']'){
			if(regex[i]==0)return 0;
			++len;
			++i;
		}
		CmpChars *pars = new CmpChars();
		if(pars->init(start, len)){
			delete pars;
			return 0;
		}
		parsed=pars;
		++i;
	}else if(regex[i]=='$'){
		++i;
		if(regex[i])return 0;
		parsed = new End();
		return regex+i;
	}else return 0;

	if(regex[i]=='*'){
		parsed->setMin(0);
		parsed->setMax(-1);
		++i;
	}else if(regex[i]=='+'){
		parsed->setMin(1);
		parsed->setMax(-1);
		++i;
	}else if(regex[i]=='?'){
		parsed->setMin(0);
		parsed->setMax(1);
		++i;
	}

	return regex+i;
}

uint32_t parse(char *regex, RegexObject*& parsed){
	uint32_t i;
	char *end=regex;
	RegexObject *act, *temp;
	char *actPos;

	while(*end)*end++;

	if(regex[0]=='^'){
		act = new Start(1);
		*regex++;
	}else{
		act = new Start(0);
	}
	parsed=act;
	actPos=regex;

	for(;;){
		if(end<=actPos)return YES;
		actPos=parseOne(actPos, temp);
		if(!actPos)return ERROR;
		act->setNext(temp);
		act=temp;
	}

	return YES;
}

int main(){
	uint32_t i;
	uint32_t temp;
	char *input = (char *)malloc(sizeof(char)*0x10000);
	char *regex = (char *)malloc(sizeof(char)*0x1000);

	RegexObject *testing=0;

	fgets(input, 0xFFFF, stdin);
	i=strlen(input)-1;
	if(input[i]=='\n'){
		input[i--]=0;
		if(input[i]=='\r')input[i--]=0;
	}

	fgets(regex, 0xFFF, stdin);
	i=strlen(regex)-1;
	if(regex[i]=='\n'){
		regex[i--]=0;
		if(regex[i]=='\r')regex[i--]=0;
	}

	if(temp=isValid(input)){
		free(regex);
		free(input);
		return temp;
	}

	if(temp=parse(regex, testing)){
		free(regex);
		free(input);
		return temp;
	}

	temp=testing->check(input);

	delete testing;

	free(regex);
	free(input);

	return temp;
}
